<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <div
            class="px-4 py-2 flex flex-col gap-2"
        >
            <navigation-bar />
            <credit-balance-box
                :credit-id="2"
            />
            <div
                class="border-b border-gray-400 pt-2 mb-2"
            />
            <div>
                <div class="pl-2 font-black">{{ $t('transfer_to_other_investors') }}</div>
                <div
                    class="my-2"
                >
                    <input
                        v-model="username"
                        type="text"
                        name="username"
                        class="input-box"
                        :placeholder="$t('username')"
                        @keyup="tryLoadName"
                    />
                    <div
                        v-if="name"
                        class="text-sm text-gray-400"
                    >
                        {{ name }}
                    </div>
                </div>
                <div
                    class="my-2 relative"
                >
                    <div
                        class="absolute inset-y-0 left-0 flex items-center cursor-pointer pl-5 text-2xl font-bold font-mono"
                    >
                        $
                    </div>
                    <input
                        v-model="amount"
                        type="tel"
                        name="username"
                        class="input-box !pl-11"
                        :placeholder="1000"
                    />
                </div>
                <div class="text-sm text-gray-400">{{ $t('please_keyin_the_desired_transfer_amount_to_receiver_credit_2_min_1_no_decimals') }}</div>
                <div
                    class="my-6"
                >
                    <auto-button
                        :block="true"
                        :busy="!canSubmit || busy"
                        :disabled="!canSubmit || busy"
                        class="uppercase font-black text-xl tracking-wider"
                        @click="password2Prompt = true"
                    >
                        {{ $t('transfer') }}
                    </auto-button>
                </div>
            </div>
            <password2-prompt
                v-if="password2Prompt"
                @confirm="onPassword2Confirmed"
                @close="password2Prompt = false"
            />
        </div>
    </div>
</template>

<script setup>
import {onMounted, ref, computed, inject} from "vue";
import CreditBalanceBox from '~/components/credit/balance-box.vue';
import {useUserStore} from "~/stores/user.js";
import NavigationBar from "~/pages/main/me/c2/navigation-bar.vue";
import AutoButton from "~/components/button/auto-button.vue";
import axios from "axios";
import Password2Prompt from "~/components/password2-prompt.vue";

const pageReady = ref(false);
const $userStore = useUserStore();

const busy = ref(false);
const username = ref('');
const name = ref('');
const amount = ref('');
const password2 = ref('');
const errors = ref({});

const $helper = inject('$helper');
const password2Prompt = ref(false);

onMounted(async () => {
    await $userStore.fetchAccount();
    pageReady.value = true;
});

const canSubmit = computed(() => {
    return username.value && parseFloat(amount.value) >= 1;
});

const tryLoadName = async () => {
    if (!busy.value) {
        try {
            if (name.value) name.value = '';
            if (username.value && String(username.value).length >= 6) {
                busy.value = true;
                const resp = await axios.post('/check_account_name', {
                    username: username.value
                });
                if (resp.name) {
                    name.value = resp.name;
                }
            }
        } catch (e) {
            console.log(e);
        } finally {
            busy.value = false;
        }
    }
};

const submitForm = async () => {
    if (canSubmit.value && !busy.value) {
        try {
            errors.value = {};
            busy.value = true;
            const resp = await axios.post('/credit/c2/transfer', {
                username: username.value,
                amount: amount.value,
                current_password2: password2.value,
            });

            password2.value = '';
            await $helper.alertSuccess({
                message: resp.message,
                callback: async () => {
                    username.value = '';
                    amount.value = '';
                    name.value = '';
                    await $userStore.fetchAccount();
                }
            })
        } catch (e) {
            if (e.response.data.errors) errors.value = e.response.data.errors;

            if (e.response.message) {
                await $helper.alertError({
                    message: e.response.message
                });
            }

        } finally {
            busy.value = false;
        }
    }
};

const onPassword2Confirmed = async (payload) => {
    password2.value = payload;
    password2Prompt.value = false;

    await submitForm();
};
</script>
